
#include "Penguin_Land.h"

#define BUFSIZE 1024
FILE *test;

int codekeyed (void) {
    FILE *fh;
    FILE *sh;
    int readsz;
    char *buff;
    int length;
    char *key = 0;
    char file1 [300], file2 [300];
    fprintf (stdout, "Please enter filename for the file to be encrypted\n");
    if (fgets (file1, 300, stdin) == NULL)
        printf ("error");
    filestripper (file1);
    if (strcmp (file1, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter filename for the file to be encrypted\n");
        if (fgets (file1, 300, stdin) == NULL)
            printf ("error");
        filestripper (file1);
    }
    if ((test = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "First file does not exist");
        return 7;
    }
    fclose (test);
    fprintf (stdout, "Please enter the second filename\n");
    if (fgets (file2, 300, stdin) == NULL)
        printf ("error");
    filestripper (file2);
    if (strcmp (file2, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter the second filename\n");
        if (fgets (file2, 300, stdin) == NULL)
            printf ("error");
        filestripper (file2);
    }
    if ((test = fopen (file2, "r")) != NULL) {
        fprintf (stdout, "%s already exists.\n", file2);
        fprintf (stdout, "Program aborted\n");
        fclose (test);
        return 7;
    }
    fprintf (stdout, "Please enter Key length\n");
    if (scanf ("%d", &length) == 0) {
        fprintf (stderr, "Error key length equals 0.");
        return 7;
    }
    length = abs (length);
    if ((key = charbuf (key, 300)) == NULL)
        return 7;
    readpassphrase ("Pleese enter key:\n", key, 300, RPP_REQUIRE_TTY);
    if (strlen (key) > 35) {
        fprintf (stderr, "Key to long");
        return 7;
    }
    if ((buff = charbuf (buff, BUFSIZE)) == NULL)
        return;
    memset (buff, 0, BUFSIZE);
    if ((sh = fopen (file2, "wb")) == NULL) {
        fprintf (stdout, "Error opening the file to be read\n");
        free (buff);
        return 7;
    }
    encode (key, length);
    fwrite (key, 1, length, sh);
    fclose (sh);
    memset (buff, 0, length);
    free (buff);
    fprintf (stdout, "Encoding File.\n");
    if ((fh = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "Error opening the file to be read\n");
        return 7;
    }
    if ((sh = fopen (file2, "ab")) == NULL) {
        fprintf (stdout, "Error opening the file to be wrote to\n");
        return 7;
    }
    if ((buff = charbuf (buff, BUFSIZE)) == NULL)
        return;
    memset (buff, 0, BUFSIZE);
    while ((readsz = fread (buff, 1, BUFSIZE, fh)) != 0) {
        encode (buff, readsz);
        fwrite (buff, 1, readsz, sh);
        memset (buff, 0, BUFSIZE);
    }
    fclose (fh);
    fclose (sh);
    free (buff);
    fprintf (stdout, "File encoded to file.\n");
    return 7;
}

int decodkeyed (void) {
    FILE *fh;
    FILE *sh;
    int readsz;
    char *buff;
    char *key = 0;
    uint length;
    long  long  final;
    long  long  length2;
    char file1 [300], file2 [300];
    fprintf (stdout, "Please enter filename for the file to be decrypted\n");
    if (fgets (file1, 300, stdin) == NULL)
        printf ("error");
    filestripper (file1);
    if (strcmp (file1, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter filename for the file to be decrypted\n");
        if (fgets (file1, 300, stdin) == NULL)
            printf ("error");
        filestripper (file1);
    }
    if ((test = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "First file does exist");
        return 7;
    }
    fclose (test);
    fprintf (stdout, "Please enter the second filename\n");
    if (fgets (file2, 300, stdin) == NULL)
        printf ("error");
    filestripper (file2);
    if (strcmp (file2, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter the second filename\n");
        if (fgets (file2, 300, stdin) == NULL)
            printf ("error");
        filestripper (file2);
    }
    if ((test = fopen (file2, "r")) != NULL) {
        fprintf (stdout, "%s already exists.\n", file2);
        fprintf (stdout, "Program aborted\n");
        fclose (test);
        return 7;
    }
    if ((key = charbuf (key, 300)) == NULL)
        return 7;
    readpassphrase ("Pleese enter key:\n", key, 300, RPP_REQUIRE_TTY);
    if (strlen (key) > 35) {
        fprintf (stderr, "Key to long");
        return 7;
    }
    fprintf (stdout, "Please enter length of key\n");
    if (scanf ("%d", &length) == 0) {
        fprintf (stderr, "Error key length equals 0");
        return 7;
    }
    if ((length = abs (length)) == 0) {
        fprintf (stdout, "zero was given for length of key" "please enter again\n");
        if (scanf ("%d", &length) == 0) {
            fprintf (stderr, "Error key length equals 0");
            return 7;
        }
        if ((length = abs (length)) == 0) {
            fprintf (stdout, "zero entered again\n");
            fprintf (stdout, "Program terminated\n");
        }
        return 7;
    }
    if ((buff = charbuf (buff, BUFSIZE)) == NULL)
        return;
    memset (buff, 0, BUFSIZE);
    memset (buff, 0, BUFSIZE);
    if ((fh = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "Error opening the file to be read\n");
        free (buff);
        return 7;
    }
    if ((fread (buff, 1, length, fh)) != length) {
        fprintf (stdout, "Error getting key for file\n");
        free (buff);
        return 7;
    }
    decode (buff, length);
    final = atoll (buff);
    fclose (fh);
    memset (buff, 0, length);
    free (buff);
    length2 = strlen (key);
    if (final != length2) {
        fprintf (stdout, "Keys do not match\n");
        return 7;
    }
    fprintf (stdout, "Decoding File.\n");
    if ((fh = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "Error opening the file to be read\n");
        return 7;
    }
    if ((sh = fopen (file2, "wb")) == NULL) {
        fprintf (stdout, "Error opening the file to be written to\n");
        return 7;
    }
    if ((buff = charbuf (buff, BUFSIZE)) == NULL)
        return;
    memset (buff, 0, BUFSIZE);
    if ((fread (buff, 1, length, fh)) != length) {
        fprintf (stdout, "Error advancing to skip the key for write\n");
        free (buff);
        return 7;
    }
    while ((readsz = fread (buff, 1, BUFSIZE, fh)) != 0) {
        decode (buff, readsz);
        fwrite (buff, 1, readsz, sh);
        memset (buff, 0, BUFSIZE);
    }
    fclose (fh);
    fclose (sh);
    memset (buff, 0, BUFSIZE);
    free (buff);
    fprintf (stdout, "File decoded to file.\n");
    return 7;
}

